#ifndef FILTER_H
#define FILTER_H

#include <inttypes.h>

#include "ugen.h"

typedef enum {
    FILTER_CF = 0,
    FILTER_RES,
    FILTER_IN,
    FILTER_NUM_PARAMS
} FILTER_PARAMS;

typedef struct {
    double *in;
    double *out;

    double cutoff; /* in Hz */
    double res; /* 0 - 1 */
    double sr;

    /* internal data */
    double kp, k, pp1d2;
    double xnm1, y1nm1, y2nm1, y3nm1;
    double y1n, y2n, y3n, y4n;

} FILTER_DATA;

void *filter_construct(int sr);

void filter_process(void *data);

void filter_destroy(void *data);

void filter_set_param(void *data, int index, double value);

double *filter_get_input(void *data, int index);

void filter_set_output(void *data, int index, double *out_buffer);

void filter_get_ugen_info(ugen_t *ugen_data);

#endif // FILTER_H


