#include <inttypes.h>

#include "ugen.h"

typedef enum {
    WSHAPER_IN,
    WSHAPER_DEPTH,
    WSHAPER_MORPH_RATIO,
    WSHAPER_NUM_PARAMS
} WSHAPER_PARAMS;

#define WSHAPER_TAB_LEN 4096

typedef struct {
    double *in;
    double *out;

    double depth;
    double morphratio;
    double shaper[WSHAPER_TAB_LEN];
    double shaper2[WSHAPER_TAB_LEN];
} WSHAPER_DATA;

void *wshaper_construct();

void wshaper_process(void *data);

void wshaper_destroy(void *data);

void wshaper_set_param(void *data, int index, double value);

double *wshaper_get_input(void *data, int index);

void wshaper_set_output(void *data, int index, double *out_buffer);

void wshaper_get_ugen_info(ugen_t *ugen_data);

